#include "ff.h"			/* FatFs configurations and declarations */
#include "diskio.h"		/* Declarations of low level disk I/O functions */
#include "../common.h"


/* global constant */
unsigned short  s_bytes_per_sector;  /* bytes per sector */
unsigned int    s_bytes_per_block;   /* bytes per block */
unsigned int    s_max_lba;           /* max logical block address */
unsigned int    s_DbrOffset;  /* offset of dbr */
unsigned char   s_BlocksPerSector=1; /* block numbers per sector */ /* bIɂPƂĂ */

// in main.c global
extern int file_size_all;
extern int file_size_data;
extern short nChannels; 
extern int nSamplesPerSec; 
extern short wBitsPerSample; 
int size_of_head;



#ifndef NULL
#define NULL    0
#endif
#ifndef TRUE
 #define TRUE           1
#endif
#ifndef FALSE
 #define FALSE          0
#endif

/* medium connect flag */
unsigned char s_IsMediumConnect=FALSE;
unsigned char s_CheckDir=FALSE;
unsigned char Stat_FatFs = STA_NOINIT;	/* Physical drive status */
/*******************/


/* Reate FileName */
#define MAX_FILE0 90   /* [̎ceʂlčő吔߂邱 */
#define MAX_SIEZ0 13
static char s_WavFileName_table[MAX_FILE0][13];
static short p_WavFileName_table[MAX_FILE0];
static unsigned char  s_WavFileId;
int WAV_FILE_5ff=0;
/********************/
FATFS Fatfs[1];		/* File system object for each logical drive */
FIL   File_Obj[1];     /* Kazuha Minaosu Koto ! */


typedef unsigned long   uint32_t;
typedef unsigned short uint16_t;
typedef unsigned char  uint8_t;
typedef int FS_INT;
typedef unsigned short FS_WORD; 
typedef unsigned long FS_DWORD;  


static void init_fatfs(BYTE drv);
static void init_fatfs2(BYTE drv);
int fopen_fatfs(int fileTh);
void fclose_fatfs(void);
int fread_fatfs(char *pd0, int c1);
static FRESULT scan_files_ff (char* path0 );

extern int send_cbw_a(int code0, unsigned char *dat8, unsigned int addrs, unsigned char count0);




int debug_printf(const char* format, ...);

/************************************************************/
unsigned char *return_file_name0(int track0a)
{
    return (unsigned char *) &s_WavFileName_table[track0a][0];
}


int fread_fatfs(char *pd0, int c1)
{
   unsigned int c0;

   f_read( &File_Obj[0] , pd0, (unsigned int) c1, &c0); 

  return c0;
}

int scan_files_ff2(void)
{
  init_fatfs(0);
  return scan_files_ff("\\");
} 

int conv_int(char *x)
{
  union  ux2
  {
    int  l0;
    char c0[4];
  } uic2;

  uic2.c0[0]=x[3]; uic2.c0[1]=x[2]; uic2.c0[2]=x[1]; uic2.c0[3]=x[0];
  return uic2.l0;
}

short conv_short(char *x)
{
  union  ux3
  {
    short  l0;
    char c0[2];
  } uic3;

  uic3.c0[0]=x[1]; uic3.c0[1]=x[0]; 
  return uic3.l0;
}

int check_data0(char *x, char *y)
{
  if( (x[0]==y[0])  && (x[1] ==y[1]) && (x[2]== y[2])  &&  (x[3]==y[3])) return 1;
  else -1;
}


/*
int check_data0(char *x)
{
  if( (x[0]=='d')  && (x[1] == 'a') && (x[2]== 't')  &&  (x[3]=='a')) return 1;
  else -1;
}

int check_data2(char *x)
{
  if( (x[0]=='f')  && (x[1] == 'm') && (x[2]== 't')  &&  (x[3]==' ')) return 1;
  else -1;
}
*/

/*--------------------------------------------------------------------------

   Public Functions

---------------------------------------------------------------------------*/
static void init_fatfs(
	BYTE drv		/* Physical drive number (0) */
)
{
#ifdef DEG01
    debug_printf ("+fmount of ff \n");
#endif
    f_mount( drv , &Fatfs[0]);
    

}

static void init_fatfs2(
	BYTE drv		/* Physical drive number (0) */
)
{

    f_mount( drv , NULL);
#ifdef DEG01
    debug_printf ("+set fmount NULL \n");
#endif

}

int fopen_fatfs(
       int FileTh		/*  file number (0) */
)
{
   FRESULT ret0;
   char file_head1[5];
   unsigned int c0;
   int file_size_fmt,i,c1;
   
   c1=0;
   ret0 = f_open(  &File_Obj[0] ,(const char *)s_WavFileName_table[FileTh] , FA_READ);

   if( ret0 != FR_OK)
   {
#ifdef DEG44
      debug_printf ("-fopen of ff error  %d\n", ret0);
#endif
      size_of_head=0;
      return c1;
   }

   //RIFFǂ
   f_read(  &File_Obj[0] , file_head1, 4, &c0); c1+=c0;
#ifdef DEG44
   file_head1[4]=0x00;
   debug_printf ("%s\n", file_head1);
#endif
   //t@CTCYǂށBWoCgȂB
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
   file_size_all=conv_int( file_head1);
#ifdef DEG44
   debug_printf("file_size_all= %d\n", file_size_all);
#endif
   //t@C^CvǂށB WAVE
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
   
   
   // sub chanck fmt 
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;

#define MAX_SEARCH 1024
   for(i=0;i<1024;++i)
   {
     if(check_data0(file_head1, "fmt ") == 1)
     {
     	// read file_size_fmt
        f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
        file_size_fmt=conv_int( file_head1); 
     	 
#ifdef DEG44
      debug_printf("file_size_fmt= %d\n", file_size_fmt);
#endif
      break;
      }
       file_head1[0]=file_head1[1];
       file_head1[1]=file_head1[2];
       file_head1[2]=file_head1[3];
       f_read( &File_Obj[0] , &file_head1[3],1, &c0); c1+=c0;
   }

   /* WAVEFORMATEX */
   // wFormatTag
   f_read( &File_Obj[0] , file_head1,2, &c0); c1+=c0;
   // nChannels
   f_read( &File_Obj[0] , file_head1,2, &c0); c1+=c0;
   nChannels=conv_short( file_head1);
#ifdef DEG44
   debug_printf("channel= %d\n",nChannels );
#endif
   // nSamplesPerSec
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
   nSamplesPerSec=conv_int( file_head1);
#ifdef DEG44
   debug_printf("nSamplesPerSec= %d\n", nSamplesPerSec);
#endif
   // nAvgBytesPerSec
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
   // nBlockAlign
   f_read( &File_Obj[0] , file_head1,2, &c0); c1+=c0;
   // wBitsPerSample
   f_read( &File_Obj[0] , file_head1,2, &c0); c1+=c0;
   wBitsPerSample=conv_short( file_head1);
#ifdef DEG44
   debug_printf("wBitsPerSample= %d\n",wBitsPerSample);
#endif
   // cbSize
   if( file_size_fmt == 18) {f_read( &File_Obj[0] , file_head1,2, &c0); c1+=c0;}
   /* WAVEFORMATEX */

  // sub chank
   f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
   
   file_size_data=0;
// #define MAX_SEARCH 1024
   for(i=0;i<1024;++i)
   {
     if(check_data0(file_head1, "data") == 1)
     {
      // file_size_data (actual data area size)
      f_read( &File_Obj[0] , file_head1,4, &c0); c1+=c0;
      file_size_data=conv_int( file_head1);
#ifdef DEG44
      debug_printf("file_size_data= %d\n", file_size_data);
#endif
      break;
      }
       file_head1[0]=file_head1[1];
       file_head1[1]=file_head1[2];
       file_head1[2]=file_head1[3];
       f_read( &File_Obj[0] , &file_head1[3],1, &c0); c1+=c0;

   }
  

#ifdef DEG44
  debug_printf("Fs= %d Hz, Bits= %d\n",nSamplesPerSec, wBitsPerSample);
#endif

  ////f_close( &File_Obj[0] );
  
   // return size of header size
   size_of_head=c1;
   return  c1;
}


void fclose_fatfs(void)
{
      f_close( &File_Obj[0] );
#ifdef DEG44
      debug_printf ("+fclose of ff \n");
#endif

}


/*-----------------------------------------------------------------------*/
/* MISC                                                                  */
/*-----------------------------------------------------------------------*/
static FRESULT scan_files_ff (
	char* path		/* Pointer to the path name working buffer */
)
{
	DIR dirs;
        FILINFO Finfo;
	FRESULT res;
	int  i,j,c0;
        unsigned char n1,n2;
        char nc0;
        short ns0;
	
        


        WAV_FILE_5ff = 0;

	if ((res = f_opendir(&dirs, path)) == FR_OK) 
        {
		
               
               
               /* FAT16 max files 256      */
               for(i=0;i<256;++i)
               {
                 res = f_readdir(&dirs, &Finfo);
                 if( (res != FR_OK) || (Finfo.fname[0]==0)) 
                 {
#ifdef DEG01
                   debug_printf ("-f_readdir of ff error %d\n", res);
#endif
                   break;
                 }
                 if( Finfo.fname[0]=='.')
                 {
#ifdef DEG01
                    debug_printf ("-fname is dot \n");
#endif
                    continue;
                 }

                 if(Finfo.fattrib & AM_DIR)
                 {
                   ////debug_printf ("No. %d , Directory, %s\n",i , Finfo.fname);
                 }
                 else
                 {
                   ////debug_printf ("No. %d , File, %s\n",i , Finfo.fname);


                  /* SFN t@C̐擪2̐Ł@\[eBO@vO */
                  if(WAV_FILE_5ff < MAX_FILE0)
                  {
                     for(j=0;j<MAX_SIEZ0;++j)
                     {
                       s_WavFileName_table[WAV_FILE_5ff][j]= Finfo.fname[j];
                       if(Finfo.fname[j] == 0x00) { c0= j; break;}
                     }
                     
                     if( s_WavFileName_table[WAV_FILE_5ff][MAX_SIEZ0-1] != 0x00)
                         {  s_WavFileName_table[WAV_FILE_5ff][MAX_SIEZ0-1] =0x00; c0= MAX_SIEZ0-1;}
                 
                        /* SFN łׂ͂đ啶ɕϊ */
                        if( (c0 >=4)  && (check_data0( &Finfo.fname[c0-4], ".WAV") == 1) )
                        {

                          n1 = (unsigned char)s_WavFileName_table[WAV_FILE_5ff][0];
                          n2 = (unsigned char)s_WavFileName_table[WAV_FILE_5ff][1];
                     
                          if( (n1 >= 0x30) && (n1 <= 0x39))   // 1st char is digit ?
                          {
                               if( (n2 >= 0x30) && (n2 <= 0x39))  // 2nd char is digit ?
                               {
                                   p_WavFileName_table[WAV_FILE_5ff]= (10 * (n1-0x30)) + (n2-0x30);
                               }
                               else p_WavFileName_table[WAV_FILE_5ff]= (n1-0x30);
                          }else  p_WavFileName_table[WAV_FILE_5ff]= 100;  // there is no digit.

          ////debug_printf ("No. %d , File, %s, headNum= %d \n",i , s_WavFileName_table[i], (int)p_WavFileName_table[WAV_FILE_5ff]);           

                           ++WAV_FILE_5ff;
                      }
                  }  // if(WAV_FILE_5ff < MAX_FILE0)
                 } // not directory if(Finfo.fattrib & AM_DIR)
               } //for(i=0;i<150;++i)

               // sort
               for(i=0;i<WAV_FILE_5ff;++i)
               {
                   c0=i;
                   for(j=i;j<WAV_FILE_5ff;++j)
                   {
                      if(p_WavFileName_table[j] < p_WavFileName_table[c0]) c0=j;
                   }
                   // exchange 
                   for(j=0;j<MAX_SIEZ0;++j)
                   {
                      nc0 = s_WavFileName_table[i][j]; 
                      s_WavFileName_table[i][j]=s_WavFileName_table[c0][j] ;
                      s_WavFileName_table[c0][j]=nc0; 
                   }
                   ns0=p_WavFileName_table[i];
                   p_WavFileName_table[i]=p_WavFileName_table[c0];
                   p_WavFileName_table[c0]=ns0;
               }
#ifdef DEG01
               for(i=0;i<WAV_FILE_5ff;++i)
               {
                  debug_printf ("No. %d , File, %s\n",i , s_WavFileName_table[i]);
               }
#endif
         }
#ifdef DEG01
         else
         {

            debug_printf ("-f_opendir of ff error %d\n", res);
            debug_printf (" number of listed files %d\n", WAV_FILE_5ff);
         }
#endif

	return res;
}



/*-----------------------------------------------------------------------*/
/* Initialize disk drive                                                 */
/*-----------------------------------------------------------------------*/

DSTATUS disk_initialize (
	BYTE drv		/* Physical drive number (0) */
)
{
        FS_INT ret0 = 0;

	if (drv) return STA_NOINIT;			/* Supports only drive 0 */
        else if (s_IsMediumConnect == FALSE) return RES_NOTRDY; /* no connection */
	else if (Stat_FatFs & STA_NODISK) return Stat_FatFs;	/* Is card existing in the soket? */

         Stat_FatFs &= ~STA_NOINIT;

#ifdef DEG41
         debug_printf ("+ disk_initialize was called from ff. \n");
#endif

       return Stat_FatFs;
}


/*-----------------------------------------------------------------------*/
/* Get disk status                                                       */
/*-----------------------------------------------------------------------*/

DSTATUS disk_status (
	BYTE drv		/* Physical drive number (0) */
)
{
	if (drv) return STA_NOINIT;		/* Supports only drive 0 */
        else if( s_IsMediumConnect == FALSE ) return STA_NODISK;  /* No connection */


	return Stat_FatFs;	/* Return disk status */
}

/*-----------------------------------------------------------------------*/
/* Read sector(s)                                                        */
/*-----------------------------------------------------------------------*/

DRESULT disk_read (
	BYTE drv,		/* Physical drive number (0) */
	BYTE *buff,		/* Pointer to the data buffer to store read data */
	DWORD sector,	/* Start sector number (LBA) */
	BYTE count		/* Number of sectors to read (1..128) */
)
{



    if (drv || !count) return RES_PARERR;		/* Check parameter */
    else if (s_IsMediumConnect == FALSE) return RES_NOTRDY; /* no connection */
    else if (Stat_FatFs & STA_NOINIT) return RES_NOTRDY;	/* Check if drive is ready */


    if( send_cbw_a(4, (unsigned char *)buff, (unsigned int) (sector + s_DbrOffset), (unsigned char) count) == -1)
    {
        return RES_ERROR;
    } 
    else return RES_OK;


}


/*-----------------------------------------------------------------------*/
/* Write sector(s)                                                       */
/*-----------------------------------------------------------------------*/
#ifdef WRITESECTOR

DRESULT disk_write (
	BYTE drv,			/* Physical drive number (0) */
	const BYTE *buff,	/* Ponter to the data to write */
	DWORD sector,		/* Start sector number (LBA) */
	BYTE count			/* Number of sectors to write (1..128) */
)
{
	
}

#endif /* WRITESECTOR */
/*-----------------------------------------------------------------------*/
/* Miscellaneous drive controls other than data read/write               */
/*-----------------------------------------------------------------------*/

DRESULT disk_ioctl (
	BYTE drv,		/* Physical drive number (0) */
	BYTE ctrl,		/* Control command code */
	void *buff		/* Pointer to the conrtol data */
)
{
	DRESULT res;
	BYTE n, csd[16], *ptr = buff;
	WORD csize;
	DWORD *dp, st, ed;


	if (drv) return RES_PARERR;					/* Check parameter */
	if (Stat_FatFs & STA_NOINIT) return RES_NOTRDY;	/* Check if drive is ready */

	res = RES_ERROR;

	switch (ctrl) {
	case CTRL_SYNC :		/* Wait for end of internal write process of the card */
		/* nothing done */
                res = RES_PARERR;
		break;

	case GET_SECTOR_COUNT :	/* Get drive capacity in unit of sector (DWORD) */
		*(WORD*)buff = s_max_lba ;
		res = RES_OK;
		break;

	case GET_SECTOR_SIZE :	/* Get sector size in unit of byte (WORD) */
		*(WORD*)buff = s_bytes_per_sector;
		res = RES_OK;
		break;

	case GET_BLOCK_SIZE :	/* Get erase block size in unit of sector (DWORD) */
		*(WORD*)buff = s_bytes_per_block;
		res = RES_OK;
		break;



	case CTRL_ERASE_SECTOR :	/* Erase a block of sectors (used when _USE_ERASE == 1) */
		/* nothing done */
                res = RES_PARERR;
		break;


	default:
		res = RES_PARERR;
	}



	return res;
}
//--------------------------------------------------------------------------------