#include "iodefine.h"
#include "i2c.h"
#include "common.h"

void init_i2c(void)
{
     /* channel 2 */

        /* clock permit */
        CPG.STBCR5.BYTE &= 0xdfu;   /* I2C Channel 2 ON */

       /* port set */
        PORT.PECR1.WORD  = 0x0011;  /* PE5 SDA2, PE4 SCL2 */
        
       /* ----IIC31 module operation enabled ---- */
       IIC3_2.ICCR1.BIT.ICE = 1u; /* IIC3W[\ */
       IIC3_2.ICCR1.BIT.RCVD = 0u; /* ̎Mp */
       IIC3_2.ICCR1.BIT.MST = 1u; /* }X^I */
       IIC3_2.ICCR1.BIT.TRS = 0u; /* MI */

       IIC3_2.ICCR1.BYTE |= 0x0f;   /* ]NbN[gFP/432(83.3kHz) */
          

       /* ---IIC bus mode register (ICMR) setting --- */
       IIC3_2.ICMR.BYTE = 0x30u;
       /*
        bit7 : MLS:0 --------------------- MSB first
        bit6-4 : Reserve:1 ----------------- Reserve bit
        bit3 : BCWP:0--------------------- Unsetting
        bit2-0 : BC0:0, BC1:0,BC0:0--------- IIC format 9-bit
       */

       /* NF2CYC is defualt */
       /* ICIER is defalut ? */

}

int i2c_write1(int rs0, unsigned char db0)
{
      int ack = E_OK;
      unsigned char send0[4];

      send0[0] = (unsigned char)(  DEVICE_ADDR2 | IIC_DATA_WR);
      if( rs0 == 0) send0[1]= 0x00; /* rs=0 cmd */
      else         send0[1]= 0x40; /* rs=1 data */
      send0[2] = db0;
  
       while(IIC3_2.ICCR2.BIT.BBSY == 1u){
         /* oX҂ */
       }

       IIC3_2.ICCR1.BYTE |= 0x30u; /* }X^M[hɐݒ */
       IIC3_2.ICCR2.BYTE = ((IIC3_2.ICCR2.BYTE & 0xbfu)|0x80u); /* Jns */

       ack=ic2_address_send(send0, 2);   /* 3oCgM */

       if(ack == E_OK)
       {
           i2c_mst_send_end();
       }
       else
       {
        /* w肵foCXACK */
          i2c_mst_send_end();
       }  

      return(ack);
}

int ic2_address_send(unsigned char* data, int code)
{

    int ack;

    ack = i2c_data_send(*data++); /* X[ufoCX̃AhX */
   if(ack == E_ERR){
      return(ack);
   }

   ack = i2c_data_send(*data++); /* rs , cmd or data  */
   if(ack == E_ERR){
     return(ack);
   }

   if( code >=2)
   {
     ack = i2c_data_send(*data); /*  data  */
     if(ack == E_ERR){
     return(ack);
     }
   }

    return(ack);
}


int i2c_data_send(unsigned char data)
{
      int ack;

      while(IIC3_2.ICSR.BIT.TDRE == 0u){
             /* ICDRT̃GveB҂ */
      }

      IIC3_2.ICDRT = data;

      while(IIC3_2.ICSR.BIT.TEND == 0u){
            /* M҂ */
      }

      if(IIC3_2.ICIER.BIT.ACKBR == 0u){
         ack = E_OK;
      }
      else{
         ack = E_ERR;
      }

       return(ack);
}


void i2c_mst_send_end(void)
{
/* ~𔭍s */


       IIC3_2.ICSR.BIT.TEND = 0u; /* TENDtONA */
       IIC3_2.ICSR.BIT.STOP = 0u; /* STOPtONA */
       IIC3_2.ICCR2.BYTE &= 0x3fu; /* ~s */

       while(IIC3_2.ICSR.BIT.STOP == 0u){
           /* oX҂ */
      }
 
      ////IIC3_2.ICCR1.BYTE &= 0xcfu; /* X[uM[h */
      ////IIC3_2.ICSR.BIT.TDRE = 0u; /* TDRENA */

}

/* */
void delay_1ms0(void)
{
	int i;
	int tmp;


	for( i = 0; i < 14400; ++i ){
		tmp = 1;
	}
}

/***************************************************************************/
#define ACK_CHECK0 1

int init_lcd(void)
{
        int i,ack;

	// RgXg̐ݒ
	////unsigned char contrast = 0x30;  ////0b0011 0000;	// 3.0V lグƔZȂ܂B

	// I2C LCD̏s܂B
	for(i=0;i<40;++i) delay_1ms0();

	ack=i2c_write1(0, 0x38);  // function set interface data 8bits, number line 2, double height font
#ifdef  ACK_CHECK0
       if( ack == E_ERR ) return 1;
#endif

        delay_1ms0();
  	ack=i2c_write1(0, 0x39);  // function set Instruction table select With interface data 8bits, number line 2
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 2;
#endif
         delay_1ms0();
	ack=i2c_write1(0, 0x14);  // interval osc 1/5bias, ajust internal OSC freq
#ifdef  ACK_CHECK0 
       if( ack == E_ERR ) return 3;
#endif
	delay_1ms0();
        ack=i2c_write1(0, 0x70 );  ////| (contrast & 0x0f)); // contrast Low
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 4;
#endif
	delay_1ms0();
	ack=i2c_write1(0, 0x5f);  ////  | ((contrast >> 4) & 0x03)); // Icon Display On, booster circuit on, contast High
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 5;
#endif
	delay_1ms0();

        ack=i2c_write1(0, 0x6c);  ////0x0110 1100); // follower control, on
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 6;
#endif
	////wait_ms(300);

         return 0;

}

void test_num2char0( int x0, unsigned char *p0)
/*  x0 is 3܂ł̐̐ */
{
      unsigned char  y0;

      p0[0]=0x30; p0[1]=0x30; p0[2]=0x30; p0[3]=0x00;  /* 000 */

      if( x0 < 0 ) 
      {
          x0=0;
      }
      if( x0 > 999) 
      {
          x0=999;
      } 
      
      y0= (unsigned char) (x0 % 10);  p0[2] +=y0;
      x0=x0/10;
      y0= (unsigned char) (x0 % 10);  p0[1] +=y0;
      x0=x0/10;
      y0= (unsigned char) x0;  p0[0] +=y0;     
}

int test_lcd_puts(unsigned char *s1, unsigned char *s2)
{
        int ack;


	ack=i2c_write1(0, 0x38);  ///0x0011 1000); // function set // function set interface data 8bits, number line 2
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 1;
#endif
        delay_1ms0();
	ack=i2c_write1(0, 0x0c);   ////0x0000 1100); // Display On
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 2;
#endif
        delay_1ms0();
	i2c_write1(0, 0x01);  ////0x00000001); // Clear Display   set ddram address
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 3;
#endif
	delay_1ms0(); delay_1ms0();			 // Clear Display͒ǉEFCgKv

	// Psڂ̕\
	while(*s1 != 0x00){
		ack=i2c_write1(1, *s1);    // write ddram
                s1++;
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 4;
#endif
                delay_1ms0();
	}

	// QsڂɃJ[\ړ
	ack=i2c_write1(0,0xc0);   ////0x11000000);	// ADDR=0x40  set ddram address
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 5;
#endif
        delay_1ms0();
	while(*s2 != 0x00){
	       ack=i2c_write1(1, *s2);    // write ddram
               s2++;
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 6;
#endif
               delay_1ms0();
	}

        return 0;

}

int test_lcd_icon(int code0)
{
        int ack;

	ack=i2c_write1(0, 0x39); /////0x0011 1001); // function set Instruction table select With interface data 8bits, number line 2
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 1;
#endif
        delay_1ms0();

	ack=i2c_write1(0, 0x46);  // select icon address 06H 
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 2;
#endif
        delay_1ms0();

        if( code0 == 1) ack=i2c_write1(1, 0x10); // 06H Icon ON
        else ack=i2c_write1(1, 0x00); // 06H Icon OFF
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 3;
#endif
       delay_1ms0();


/*
	ack=i2c_write1(0, 0x38);  ///0x0011 1000); // function set // function set interface data 8bits, number line 2
#ifdef  ACK_CHECK0
        if( ack == E_ERR ) return 4;
#endif
*/
        return 0;
}