#include "iodefine.h"
#include "ssif_ctrl.h"
#include "common.h"

extern int double_speed0;
extern int USB_INPUT0;
extern int audio_clk0;

#ifdef FORMAT_1702
extern unsigned long Data0[16][ SSI_DATASIZE0 /4];    
extern unsigned int BuffIdx0;	   
extern unsigned int BuffIdx3;
#endif



void init_ssif(void)
{
	
	/* ---- SSI 荞݃xݒ ---- */ 
	INTC.IPR15.BIT._SSI2 = 1u; /* SSI2 vs DMA 2u, DMA is priorty higher than SSI */
	INTC.IPR15.BIT._SSI1 = 1u; /* SSI1 vs DMA 2u */	
	
	
    /* SSI2 pɃ}`vbNXݒ */
	PORT.PFCR0.BIT.PF3MD	= 2;	/* SSISCK2 */
	PORT.PFCR1.BIT.PF4MD	= 2;	/* SSIWS2 */
	PORT.PFCR1.BIT.PF5MD	= 2;	/* SSIDATA2 */
	
	 /* SSI1 pɃ}`vbNXݒ */
	PORT.PFCR0.BIT.PF0MD	= 2;	/* SSISCK1 */
	PORT.PFCR0.BIT.PF1MD	= 2;	/* SSIWS1 */
	PORT.PFCR0.BIT.PF2MD	= 2;	/* SSIDATA1 */
	
	/*@X^oCRg[̉ */
	CPG.STBCR6.BIT.MSTP65	= 0;	/* SSIF2փNbN */
	CPG.STBCR6.BIT.MSTP66	= 0;	/* SSIF1փNbN */

    /* }X^[NbN̑I@*/
	SSIF2.SSICR.BIT.CKS		= 0;	/* I[oTvNbNI:AUDIO_X1*/
	

	/* o̓tH[}bgI2Sɐݒ@*/	
	SSIF2.SSICR.BIT.SCKP	= 0;	/* VArbgNbNɐ: BCKGbWŕω */
	SSIF2.SSICR.BIT.SWSP	= 0;	/* VAWSɐ LchLOW */
	SSIF2.SSICR.BIT.SPDP	= 0;	/* VApfBOɐ */
	SSIF2.SSICR.BIT.SDTA	= 0;	/* VAf[^ACg f[^̌ɃpfBOǉ*/
	SSIF2.SSICR.BIT.PDTA	= 1;	/* pf[^ACg */
	SSIF2.SSICR.BIT.DEL		= 0;	/* VAf[^fBC 1NbNfC*/

  #ifdef AUDIO_16M	
        SSIF2.SSICR.BIT.CKDV	= 8;	/* VAI[oTvNbN:AUDIO/6 ;BCK=384fs/6=64fs*/
        SSIF2.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
  #else
        SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        SSIF2.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
  #endif       


	SSIF2.SSICR.BIT.DWL	= 1;	/* f[^[h 16rbg*/	
	SSIF2.SSICR.BIT.CHNL	= 0;	/* `l PVXe[hɂP`l*/	
	SSIF2.SSICR.BIT.SCKD	= 1;	/* VArbgNbN:}X^[h */
	SSIF2.SSICR.BIT.SWSD	= 1;	/* VAWS:}X^[h */

	/* 荞݂̐ݒ */		
	SSIF2.SSICR.BIT.TUIEN	= 0;	/* MA_t[݋֎~ */
	SSIF2.SSICR.BIT.TOIEN	= 0;	/* MI[ot[݋֎~ */
	SSIF2.SSICR.BIT.RUIEN	= 0;	/* MA_t[݋֎~ */
	SSIF2.SSICR.BIT.ROIEN	= 0;	/* MI[ot[݋֎~ */
	SSIF2.SSICR.BIT.IIEN	= 0;	/* ACh[h݋֎~ */

	SSIF2.SSICR.BIT.MUEN	= 0;	/* ~[gĂȂ */
	SSIF2.SSICR.BIT.TEN		= 0;	/* M֎~ */
	SSIF2.SSICR.BIT.REN		= 0;	/* M֎~ */

    /* FIFO Rg[WX^[̐ݒ*/
	SSIF2.SSIFCR.BIT.TTRG	= 0;	/* Mf[^gK 7(SSIFDR1i) */
	SSIF2.SSIFCR.BIT.RTRG	= 0;	/* Mf[^gK */
	SSIF2.SSIFCR.BIT.TIE	= 1;	/* Mf[^GveB[荞݂̋ */
	SSIF2.SSIFCR.BIT.RIE	= 0;	/* Mf[^GveB[荞݋֎~*/
	SSIF2.SSIFCR.BIT.TFRST	= 0;	/* MFIFOWX^̃f[^Zbg */
	SSIF2.SSIFCR.BIT.RFRST	= 0;	/* MFIFOWX^̃f[^Zbg */


	

	
	
	/* ȉSSI1 SCK}X^[NbNo͗pɃ_~[Őݒ*/
	
	 /* }X^[NbN̑I@*/
	SSIF1.SSICR.BIT.CKS		= 0;	/* I[oTvNbNI:AUDIO_X1*/


	/* o̓tH[}bgI2Sɐݒ@*/	
	SSIF1.SSICR.BIT.SCKP	= 0;	/* VArbgNbNɐ: BCKGbWŕω */
	SSIF1.SSICR.BIT.SWSP	= 0;	/* VAWSɐ LchLOW */
	SSIF1.SSICR.BIT.SPDP	= 0;	/* VApfBOɐ */
	SSIF1.SSICR.BIT.SDTA	= 0;	/* VAf[^ACg f[^̌ɃpfBOǉ*/
	SSIF1.SSICR.BIT.PDTA	= 1;	/* pf[^ACg */
	SSIF1.SSICR.BIT.DEL		= 0;	/* VAf[^fBC 1NbNfC*/

       
#ifdef FORMAT_1702
 #ifdef AUDIO_16M	
        SSIF1.SSICR.BIT.CKDV	= 8;	/* VAI[oTvNbN:AUDIO/6 ;BCK=384fs/6=64fs*/
        SSIF1.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
 #else
        SSIF1.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        SSIF1.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
 #endif
#else    // For MCK Clock Setting
        SSIF1.SSICR.BIT.CKDV	= 0;	/* VAI[oTvNbN:AUDIO ;BCK=256fs ܂́@384fs*/
	SSIF1.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
#endif


	SSIF1.SSICR.BIT.DWL		= 1;	/* f[^[h 16rbg*/	
	SSIF1.SSICR.BIT.CHNL	= 0;	/* `l PVXe[hɂP`l*/	


	////SSIF1.SSICR.BIT.SCKD	= 1;	/* VArbgNbN:}X^[h */
	////SSIF1.SSICR.BIT.SWSD	= 1;	/* VAWS:}X^[h */
        
        ///********************************************************************************
        /// FORMAT 1702 SSI1SSI2Ɠ邽߁ASSI1SSI2̃X[u[hɕύXB
        ///++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	SSIF1.SSICR.BIT.SCKD	= 0;	/* VArbgNbN:X[u[h */
	SSIF1.SSICR.BIT.SWSD	= 0;	/* VAWS:X[u[h */

	/* 荞݂̐ݒ */		
	SSIF1.SSICR.BIT.TUIEN	= 0;	/* MA_t[݋֎~ */
	SSIF1.SSICR.BIT.TOIEN	= 0;	/* MI[ot[݋֎~ */
	SSIF1.SSICR.BIT.RUIEN	= 0;	/* MA_t[݋֎~ */
	SSIF1.SSICR.BIT.ROIEN	= 0;	/* MI[ot[݋֎~ */
	SSIF1.SSICR.BIT.IIEN	= 0;	/* ACh[h݋֎~ */

#ifdef FORMAT_1702
              SSIF1.SSICR.BIT.MUEN	= 0;	/* ~[gĂȂ */
#else
	SSIF1.SSICR.BIT.MUEN	= 1;	/* ~[gĂ*/
#endif

	SSIF1.SSICR.BIT.TEN		= 0;	/* M֎~ */
	SSIF1.SSICR.BIT.REN		= 0;	/* M֎~ */

    /* FIFO Rg[WX^[̐ݒ*/
	SSIF1.SSIFCR.BIT.TTRG	= 0;	/* Mf[^gK 7(SSIFDR1i) */
	SSIF1.SSIFCR.BIT.RTRG	= 0;	/* Mf[^gK */

#ifdef FORMAT_1702
              SSIF1.SSIFCR.BIT.TIE	= 1;	/* Mf[^GveB[荞݋*/
#else
	SSIF1.SSIFCR.BIT.TIE	= 0;	/* Mf[^GveB[荞݋֎~*/
#endif
	SSIF1.SSIFCR.BIT.RIE	= 0;	/* Mf[^GveB[荞݋֎~*/
	SSIF1.SSIFCR.BIT.TFRST	= 0;	/* MFIFOWX^̃f[^Zbg */
	SSIF1.SSIFCR.BIT.RFRST	= 0;	/* MFIFOWX^̃f[^Zbg */


             /* SSI1 ́@Ɂ@SSI2ƂƂɑMĂ@*/
             SSIF2.SSICR.BIT.TEN		= 1;     /*M*/
	SSIF1.SSICR.BIT.TEN		= 1;     /*M*/

	
	
	
}

int change_ssi2_bck()
{

int f; 
#define MAX_C0 20  //ċNMAX 
int c0,count_dma3,count_dma1;      
 volatile unsigned long dummy;

#ifdef FORMAT_1702


 c0=0;

 re_start_c0:

      //AM~
       SSIF2.SSICR.BIT.TEN		= 0;     /*M֎~*/
       SSIF1.SSICR.BIT.TEN		= 0;     /*M֎~*/
      

      //BMf[^GveB[荞݋֎~
       /* DMA v~@*/
      SSIF2.SSIFCR.BIT.TIE	= 0;	/* Mf[^GveB[荞݋֎~*/
      SSIF1.SSIFCR.BIT.TIE	= 0;	/* Mf[^GveB[荞݋֎~*/


     //CPUSH 
    /* DMAC ̒~Ə   */
       DMAC.CHCR1.BIT.DE    = 0;		/* DMA transfer disabled */
       DMAC.CHCR3.BIT.DE    = 0;		/* DMA transfer disabled */
       DMAC.CHCR1.BIT.TE     = 0;		/* Transfer end flag clear */
       DMAC.CHCR3.BIT.TE     = 0;		/* Transfer end flag clear */

       BuffIdx0 = 0u;	   
       BuffIdx3 = 0u;

       DMAC.SAR1.LONG = (unsigned long)Data0[2];
       DMAC.RSAR1.LONG= (unsigned long)Data0[10]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */  
       DMAC.DAR1.LONG = (unsigned long)&SSIF2.SSIFTDR; /* ---- DMA fXeBl[VAhXWX^̐ݒ ---- */ 
       DMAC.DMATCR1.LONG =SSI_DATASIZE2;
       DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;
	 
       DMAC.SAR3.LONG = (unsigned long)Data0[5];
       DMAC.RSAR3.LONG= (unsigned long)Data0[13]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
       DMAC.DAR3.LONG = (unsigned long)&SSIF1.SSIFTDR; /* ---- DMA fXeBl[VAhXWX^̐ݒ ---- */ 
       DMAC.DMATCR3.LONG =SSI_DATASIZE2;
       DMAC.RDMATCR3.LONG= SSI_DATASIZE2 ;	 


       //D
#define MAX_fX0   0x100000
        f=0;
        while(1)       /*@AChɂȂ܂ő҂ */
        {
           if( (SSIF2.SSISR.BIT.IDST != 0) && (SSIF1.SSISR.BIT.IDST != 0) ) break;
           if( f > MAX_fX0 ) break; else ++f;
        }





   /* }X^[NbN̑I@*/
	if( audio_clk0 == 1)
        {
           SSIF2.SSICR.BIT.CKS		= 1;	/* I[oTvNbNI:AUDIO_CLK*/
           SSIF1.SSICR.BIT.CKS		= 1;
	}
        else
        {
           SSIF2.SSICR.BIT.CKS		= 0;	/* I[oTvNbNI:AUDIO_X1*/
           SSIF1.SSICR.BIT.CKS		= 0;
        }



     

 #ifdef AUDIO_16M	

  #ifdef AUDIO_CLK_USE
    if( audio_clk0 == 1)
    {
      SSIF2.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        else if(double_speed0 == 4) SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
        else   SSIF2.SSICR.BIT.CKDV	= 3;	/* VAI[oTvNbN:AUDIO/8 ;BCK=256fs/8=32fs*/
 
        SSIF1.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF1.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        else if(double_speed0 == 4) SSIF1.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
        else   SSIF1.SSICR.BIT.CKDV	= 3;	/* VAI[oTvNbN:AUDIO/8 ;BCK=256fs/8=32fs*/
       
    }
    else
    {
  #endif
        SSIF2.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF2.SSICR.BIT.CKDV	= 8;	/* VAI[oTvNbN:AUDIO/6 ;BCK=384fs/6=64fs*/
        /// else if(double_speed0 == 4) SSIF2.SSICR.BIT.CKDV	= xxxx;	//4{p̐ݒ肪ȂI/* VAI[oTvNbN:AUDIO/3 ;BCK=384fs/3=128fs*/
        else 
          SSIF2.SSICR.BIT.CKDV	= 9;	/* VAI[oTvNbN:AUDIO/12 ;BCK=384fs/12=32fs*/
        
        SSIF1.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF1.SSICR.BIT.CKDV	= 8;	/* VAI[oTvNbN:AUDIO/6 ;BCK=384fs/6=64fs*/
        /// else if(double_speed0 == 4) SSIF1.SSICR.BIT.CKDV	= xxxx;	//4{p̐ݒ肪ȂI/* VAI[oTvNbN:AUDIO/3 ;BCK=384fs/3=128fs*/
        else 
          SSIF1.SSICR.BIT.CKDV	= 9;	/* VAI[oTvNbN:AUDIO/12 ;BCK=384fs/12=32fs*/
  
 #ifdef AUDIO_CLK_USE
     }
 #endif


    #else
         SSIF2.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        else if(double_speed0 == 4) SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
     

        else if(double_speed0 == 8) SSIF2.SSICR.BIT.CKDV	= 0;	/* VAI[oTvNbN:AUDIO/1 ;BCK=256fs/1=256fs*/
     
         else   SSIF2.SSICR.BIT.CKDV	= 3;	/* VAI[oTvNbN:AUDIO/8 ;BCK=256fs/8=32fs*/
 
        SSIF1.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        if(double_speed0 == 2) SSIF1.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        else if(double_speed0 == 4) SSIF1.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
       

        else if(double_speed0 == 8) SSIF1.SSICR.BIT.CKDV	= 0;	/* VAI[oTvNbN:AUDIO/1 ;BCK=256fs/1=256fs*/

         else   SSIF1.SSICR.BIT.CKDV	= 3;	/* VAI[oTvNbN:AUDIO/8 ;BCK=256fs/8=32fs*/
       
        

   #endif


   /* o̓tH[}bgone chɐݒ@*/
        /* f[^[h = VXe[h@16rbg*/
        /* P[hƑQ[h1f[^iЂjō\ */
        /* WSo͂LEɑ  */
	SSIF2.SSICR.BIT.SCKP	= 0;	/* VArbgNbNɐ: BCKGbWŕω */
	SSIF2.SSICR.BIT.SWSP	= 0;	/* VAWSɐ LchLOW */
	SSIF2.SSICR.BIT.SPDP	= 0;	/* VApfBOɐ */
	SSIF2.SSICR.BIT.SDTA	= 1;	/* VAf[^ACg f[^̑OɃpfBOǉ*/
	SSIF2.SSICR.BIT.PDTA	= 1;	/* pf[^ACg */
                                        /* P[h@Q[h̏Ԃ */
	SSIF2.SSICR.BIT.DEL		= 1;	/* VAf[^fBCȂ*/	



	SSIF1.SSICR.BIT.SCKP	= 0;	/* VArbgNbNɐ: BCKGbWŕω */
	SSIF1.SSICR.BIT.SWSP	= 0;	/* VAWSɐ LchLOW */
	SSIF1.SSICR.BIT.SPDP	= 0;	/* VApfBOɐ */
	SSIF1.SSICR.BIT.SDTA	= 1;	/* VAf[^ACg f[^̑OɃpfBOǉ*/
	SSIF1.SSICR.BIT.PDTA	= 1;	/* pf[^ACg */
                                        /* P[h@Q[h̏Ԃ */
	SSIF1.SSICR.BIT.DEL		= 1;	/* VAf[^fBCȂ*/	





    /* EFIFO ɂ*/
	SSIF2.SSIFCR.BIT.TFRST	= 1;	/* MFIFOWX^̃f[^Zbg */
	SSIF1.SSIFCR.BIT.TFRST	= 1;	/* MFIFOWX^̃f[^Zbg */



	
        //FFIFOɗf[^
 //     usb @\̕sɂȂH
 //       for(f=0;f<8;++f)
 //       {
 //         SSIF2.SSIFTDR = 0;
 //         SSIF1.SSIFTDR = 0;
 //       }

       // G߂ɃGveB[tOZbgĂ݂
    SSIF2.SSIFSR.BIT.TDE = 1;   /* MFIFOWX^@GveB[*/
    SSIF1.SSIFSR.BIT.TDE = 1;   /* MFIFOWX^@GveB[*/


         
	SSIF2.SSIFCR.BIT.TFRST	= 0;	/* MFIFOWX^̃f[^Zbgs */
	SSIF1.SSIFCR.BIT.TFRST	= 0;	/* MFIFOWX^̃f[^Zbgs */
  


       //CPOP DMAҋ@ĊJ
       DMAC.DMAOR.WORD &= 0xFFF9u; /* AE,NMIF rbgNA */
       DMAC.CHCR1.BIT.DE    = 1;		/* DMA transfer enabled */
       DMAC.CHCR3.BIT.DE    = 1;		/* DMA transfer enabled */
       dummy = DMAC.CHCR1.BIT.TE; /* _~[[h */
       dummy = DMAC.CHCR3.BIT.TE; /* _~[[h */


	/* ---- SSI 荞݃xݒ ---- */ 
	INTC.IPR15.BIT._SSI2 = 3u; /* SSI2 */
	INTC.IPR15.BIT._SSI1 = 3u; /* SSI1 */	
	

       //BPOP
       SSIF2.SSIFCR.BIT.TIE	= 1;	/* Mf[^GveB[荞݋*/
       SSIF1.SSIFCR.BIT.TIE	= 1;	/* Mf[^GveB[荞݋*/	  


      //APOP@M
      SSIF1.SSICR.BIT.TEN		= 1;     /*M*/
      SSIF2.SSICR.BIT.TEN		= 1;     /*M*/
   
    //H@SSIɋNꂽǂ`FbNB@
     for( f=16000; f >0; f--) { /* 1.1ms = (1/44.1KHz ) * 32 bit * 1.5 cyc */
        /* wait */  }

	 
    if( (SSIF2.SSISR.BIT.IDST == 0) && (SSIF1.SSISR.BIT.IDST == 0) ) {  /* N */ }
    else 
    {
       if( c0 < MAX_C0) {
     for( f=16000; f >0; f--) { /* 1.1ms = (1/44.1KHz ) * 32 bit * 1.5 cyc */
        /* wait */  }
         c0++; goto re_start_c0;
       }
   }

   //IDMAC Nā@񐔂Ă邩ǂ@`FbNB
   if(( DMAC.DMATCR1.LONG ==SSI_DATASIZE2) || ( DMAC.DMATCR3.LONG ==SSI_DATASIZE2) )
   {
     if( c0 < MAX_C0)  { c0++; goto re_start_c0;}
   }
   
   //JԂĂDMA3̃JEgi܂Ȃ悤Ȃ烊gC
   count_dma3=DMAC.DMATCR3.LONG;
   count_dma1=DMAC.DMATCR1.LONG;
   for( f=16000; f >0; f--) { /* 1.1ms = (1/44.1KHz ) * 32 bit * 1.5 cyc */
        /* wait */  }
   if( (DMAC.DMATCR3.LONG == count_dma3) || (DMAC.DMATCR1.LONG == count_dma1) )
   {
      if( c0 < MAX_C0)  { c0++; goto re_start_c0;}
   }
 
   //Klł邱Ƃ̏ǉ

   for( f=16000; f >0; f--) { /* 1.1ms = (1/44.1KHz ) * 32 bit * 1.5 cyc */
        /* wait */  }
   if( DMAC.DMATCR3.LONG != DMAC.DMATCR1.LONG ) 
   {
      if( c0 < MAX_C0)  { c0++; goto re_start_c0;}
   }


#else   //#ifdef FORMAT_1702
//  

{  

         SSIF2.SSICR.BIT.TEN		= 0;     /*M֎~*/

        while(1)       /*@AChɂȂ܂ő҂ */
        {
           if( SSIF2.SSISR.BIT.IDST != 0 ) break;
        }

    /* }X^[NbN̑I@*/
	if( audio_clk0 == 1) SSIF2.SSICR.BIT.CKS		= 1;	/* I[oTvNbNI:AUDIO_CLK*/
	else SSIF2.SSICR.BIT.CKS		= 0;	/* I[oTvNbNI:AUDIO_X1*/


   #ifdef AUDIO_16M	
    #ifdef AUDIO_CLK_USE
        if( audio_clk0 == 1)
        {
        SSIF2.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
        if(double_speed0 == 2) SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
        else if(double_speed0 == 4) 
        {
           SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
           SSIF2.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        }
        else   SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        
        }
        else
        {
    #endif

        if(double_speed0 == 2) 
        {
          SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=384fs/4=96fs*/
    	  SSIF2.SSICR.BIT.SWL		= 2;	/* VXe[h:24rbg */
        }  
        else if(double_speed0 == 4) 
        {
          SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=384fs/2=192fs*/
    	  SSIF2.SSICR.BIT.SWL		= 2;	/* VXe[h:24rbg */
        } 
        else 
        {
          SSIF2.SSICR.BIT.CKDV	= 8;	/* VAI[oTvNbN:AUDIO/6 ;BCK=384fs/6=64fs*/
          SSIF2.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
        }
#ifdef AUDIO_CLK_USE
        }
#endif


   #else
         SSIF2.SSICR.BIT.SWL		= 3;	/* VXe[h:32rbg */
        if(double_speed0 == 2) SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
        else if(double_speed0 == 4) 
        {
           SSIF2.SSICR.BIT.CKDV	= 1;	/* VAI[oTvNbN:AUDIO/2 ;BCK=256fs/2=128fs*/
           SSIF2.SSICR.BIT.SWL		= 1;	/* VXe[h:16rbg */
        }
        else   SSIF2.SSICR.BIT.CKDV	= 2;	/* VAI[oTvNbN:AUDIO/4 ;BCK=256fs/4=64fs*/
        
   #endif

     SSIF2.SSICR.BIT.TEN		= 1;     /*M*/

}

#endif 

return c0;

}

