/*""FILE COMMENT""**************************************************************
*
*       System Name : SH7670 USB Sample Program
*       File Name   : h_usbint.c
*       Contents    : Hsot USB Interrupt
*       Version     : 2.01.00
*       Model       : M3A-HS71
*       CPU         : SH7670
*       Compiler    : SHC9.1.1.0
*       OS          : none
*
*       note        :
*                     <ӎ>
*                     {TvvOׂ͂ĎQlłA
*                     ̓ۏ؂̂ł͂܂B
*                     {TvvO͂ql̃\tgEGAJ
*                     ZpQlƂĂp
*
*       The information described here may contain technical inaccuracies or
*       typographical errors. Renesas Technology Corporation and Renesas Solutions
*       assume no responsibility for any damage, liability, or other loss rising 
*       from these inaccuracies or errors.
*
*       Copyright (C) 2008 Renesas Technology Corp. All Rights Reserved
*       AND Renesas Solutions Corp. All Rights Reserved
*
*       history   : 2008.01.09 ver.1.00.00 
*                 : 2008.01.17 ver.2.00.00 
*                 : 2008.09.02 ver.2.01.00 
*""FILE COMMENT END""*********************************************************/

/******* include file ********************************************************/
#include "..\..\inc\usb.h"

/*""FUNC COMMENT""************************************************************ 
* ID         : 
* Outline    : USB interrupt
*----------------------------------------------------------------------------- 
* Include    : 
*----------------------------------------------------------------------------- 
* Declaration: void H_USBInterrupt(void)
*----------------------------------------------------------------------------- 
* Function   : 
*            : 
*----------------------------------------------------------------------------- 
* Argument   : void
*----------------------------------------------------------------------------- 
* ReturnValue: void
*----------------------------------------------------------------------------- 
* Notice     : 
*            : 
*""FUNC COMMENT END""*********************************************************/
void H_USBInterrupt(void)
{
	USB_U16	intsts0, intsts1;
	USB_U16	intenb0, intenb1;
	USB_U16	brdysts, nrdysts, bempsts;
	USB_U16	brdyenb, nrdyenb, bempenb;

	intsts0 = USB.INTSTS0.WORD;
	intsts1 = USB.INTSTS1.WORD;
	intenb0 = USB.INTENB0.WORD;
	intenb1 = USB.INTENB1.WORD;

	if( (intsts1 & BITBCHG) && (intenb1 & BITBCHGE) ) {
			USB.INTSTS1.WORD = (USB_U16)~BITBCHG;				/* Status Clear */
			USB.INTENB1.BIT.BCHGE = 0;
			UsbBchgFlg = USB_YES;						/* Flag set */
	}
	else if( (intsts1 & BITSACK) && (intenb1 & BITSACK) ) {
		USB.INTSTS1.WORD = (USB_U16)~BITSACK;
		CHG_CMD_FIELD(UsbCmdStage, CMD_DONE);						/* DONE */
	}
	else if( (intsts1 & BITSIGN) && (intenb1 & BITSIGN) ) {
		USB.INTSTS1.WORD = (USB_U16)~BITSIGN;
		CHG_CMD_FIELD(UsbCmdStage, CMD_NORES);						/* ERROR */
	}
	else if( ((intsts1&BITDTCH)==BITDTCH) && ((intenb1&BITDTCHE)==BITDTCHE) ){
		/***** DETACH *****/
		USB.INTSTS1.WORD = (USB_U16)~BITDTCH;
		USB.INTENB1.BIT.DTCHE = 0;
		UsbDtchFlg = USB_YES;							/* Flag set */
	}
	else if( ((intsts1&BITATTCH)==BITATTCH) && ((intenb1&BITATTCHE)==BITATTCHE) ){
		/***** DETACH *****/
		USB.INTSTS1.WORD = (USB_U16)~BITATTCH;
		USB.INTENB1.BIT.ATTCHE = 0;
		UsbAtchFlg = USB_YES;							/* Flag set */
	}
	else if( (intsts0 & intenb0 & (BITBEMP|BITNRDY|BITBRDY)) ) {
		brdysts = USB.BRDYSTS.WORD;
		nrdysts = USB.NRDYSTS.WORD;
		bempsts = USB.BEMPSTS.WORD;
		brdyenb = USB.BRDYENB.WORD;
		nrdyenb = USB.NRDYENB.WORD;
		bempenb = USB.BEMPENB.WORD;

		/* Processing whithout PIPE0 data */
		if( (intsts0 & BITBRDY) && (intenb0 & BITBRDY) && (brdysts & brdyenb) ) {
			H_BRDYInterrupt(brdysts, brdyenb);
		}
		else if( (intsts0 & BITBEMP) && (intenb0 & BITBEMP) && (bempsts & bempenb) ) {
			H_BEMPInterrupt(bempsts, bempenb);
		}
		else if( (intsts0 & BITNRDY) && (intenb0 & BITNRDY) && (nrdysts & nrdyenb) ) {
			H_NRDYInterrupt(nrdysts, nrdyenb);
		}
	}
	else {
	}
}

/*===========================================================================*/
/* End of File */
